using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace Environment_Winforms_cs
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class mainForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Button getEnvironment;
		private System.Windows.Forms.Button getDrives;
		private System.Windows.Forms.Button getSpecialFolders;
		private System.Windows.Forms.ListView EnvironmentListView;
		private System.Windows.Forms.ColumnHeader columnHeader1;
		private System.Windows.Forms.ColumnHeader columnHeader2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public mainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.getEnvironment = new System.Windows.Forms.Button();
			this.getDrives = new System.Windows.Forms.Button();
			this.getSpecialFolders = new System.Windows.Forms.Button();
			this.EnvironmentListView = new System.Windows.Forms.ListView();
			this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
			this.SuspendLayout();
			// 
			// getEnvironment
			// 
			this.getEnvironment.Location = new System.Drawing.Point(16, 12);
			this.getEnvironment.Name = "getEnvironment";
			this.getEnvironment.Size = new System.Drawing.Size(160, 23);
			this.getEnvironment.TabIndex = 0;
			this.getEnvironment.Text = "Get My Environment";
			this.getEnvironment.Click += new System.EventHandler(this.getEnvironment_Click);
			// 
			// getDrives
			// 
			this.getDrives.Location = new System.Drawing.Point(16, 48);
			this.getDrives.Name = "getDrives";
			this.getDrives.Size = new System.Drawing.Size(160, 23);
			this.getDrives.TabIndex = 1;
			this.getDrives.Text = "Get Logical Drives";
			this.getDrives.Click += new System.EventHandler(this.getDrives_Click);
			// 
			// getSpecialFolders
			// 
			this.getSpecialFolders.Location = new System.Drawing.Point(16, 88);
			this.getSpecialFolders.Name = "getSpecialFolders";
			this.getSpecialFolders.Size = new System.Drawing.Size(160, 23);
			this.getSpecialFolders.TabIndex = 2;
			this.getSpecialFolders.Text = "Get Special Folders";
			this.getSpecialFolders.Click += new System.EventHandler(this.getSpecialFolders_Click);
			// 
			// EnvironmentListView
			// 
			this.EnvironmentListView.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.EnvironmentListView.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																								  this.columnHeader1,
																								  this.columnHeader2});
			this.EnvironmentListView.Location = new System.Drawing.Point(192, 8);
			this.EnvironmentListView.Name = "EnvironmentListView";
			this.EnvironmentListView.Size = new System.Drawing.Size(356, 284);
			this.EnvironmentListView.TabIndex = 3;
			this.EnvironmentListView.View = System.Windows.Forms.View.Details;
			// 
			// columnHeader1
			// 
			this.columnHeader1.Text = "Name";
			this.columnHeader1.Width = 150;
			// 
			// columnHeader2
			// 
			this.columnHeader2.Text = "Description";
			this.columnHeader2.Width = 200;
			// 
			// mainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 16);
			this.ClientSize = new System.Drawing.Size(560, 301);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.EnvironmentListView,
																		  this.getSpecialFolders,
																		  this.getDrives,
																		  this.getEnvironment});
			this.Font = new System.Drawing.Font("Tahoma", 9.75F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.Name = "mainForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Environment Settings";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new mainForm());
		}

		private void getEnvironment_Click(object sender, System.EventArgs e)
		{
 
		// Set the cursor to an hourglass
        this.Cursor  = Cursors.WaitCursor;

         // Clear the ListView of any existing items
		EnvironmentListView.Items.Clear();

		// Create a ListItem variable
		ListViewItem lvi;

		// Create a new instance of the ListItem variable
		// and re-use it for each property you add to the ListView
		lvi = new ListViewItem();

		lvi.Text = "Current Directory";
		lvi.SubItems.Add(Environment.CurrentDirectory);
		EnvironmentListView.Items.Add(lvi);

		lvi = new ListViewItem();
		lvi.Text = "Machine Name";
		lvi.SubItems.Add(Environment.MachineName);
		EnvironmentListView.Items.Add(lvi);

		lvi = new ListViewItem();
		lvi.Text = "OS Version";
		lvi.SubItems.Add(Environment.OSVersion.ToString());
		EnvironmentListView.Items.Add(lvi);

		lvi = new ListViewItem();
		lvi.Text = "System Directory";
		lvi.SubItems.Add(Environment.SystemDirectory);
		EnvironmentListView.Items.Add(lvi);

		lvi = new ListViewItem();
		lvi.Text = "Ticks since last shutdown";
		lvi.SubItems.Add(Environment.TickCount.ToString());
		EnvironmentListView.Items.Add(lvi);

		lvi = new ListViewItem();
		lvi.Text = "User Domain Name";
		lvi.SubItems.Add(Environment.UserDomainName);
		EnvironmentListView.Items.Add(lvi);

		lvi = new ListViewItem();
		lvi.Text = "User Name";
		lvi.SubItems.Add(Environment.UserName);
		EnvironmentListView.Items.Add(lvi);

		// Set the cursor back to normal
        this.Cursor = Cursors.Default;
		}

		private void getDrives_Click(object sender, System.EventArgs e)
		{

			// Set the cursor to an hourglass
			this.Cursor  = Cursors.WaitCursor;

			// Clear the ListView of any existing items
			EnvironmentListView.Items.Clear();

			// Create a ListItem variable
			ListViewItem lvi;

			// Create a string array variable called logicalDrives
			string[] logicalDrives;

			// Call the GetLogicalDrives method of the Environment class
			logicalDrives = Environment.GetLogicalDrives();

			// Loop thru the collection of drives, and add them to the ListView
			foreach(string drives in logicalDrives)
			{
				// Create a new instance of the ListItem variable
				// and re-use it for each property you add to the ListView
				lvi = new ListViewItem();
				lvi.Text = "Drive Letter";
				lvi.SubItems.Add(drives);
				EnvironmentListView.Items.Add(lvi);
			}

			// Set the cursor back to normal
			this.Cursor = Cursors.Default;

		}

		private void getSpecialFolders_Click(object sender, System.EventArgs e)
		{
			// Set the cursor to an hourglass
			this.Cursor  = Cursors.WaitCursor;

			// Clear the ListView of any existing items
			EnvironmentListView.Items.Clear();

			// Call the GetFolderPath method, passing the
			// SpecialFolder enumeration variable to ge the special Folder
			EnvironmentListView.Items.Add("Program Files").SubItems.Add
					(Environment.GetFolderPath
					(Environment.SpecialFolder.ProgramFiles));

			EnvironmentListView.Items.Add("Application Data").SubItems.Add
				(Environment.GetFolderPath
				(Environment.SpecialFolder.ApplicationData));

			EnvironmentListView.Items.Add("Personal Folder").SubItems.Add
				(Environment.GetFolderPath
				(Environment.SpecialFolder.Personal));

			EnvironmentListView.Items.Add("Local Application Data").SubItems.Add
				(Environment.GetFolderPath
				(Environment.SpecialFolder.LocalApplicationData));
			
			// Set the cursor back to normal
			this.Cursor = Cursors.Default;

		}
	}
}
